Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs	(revision 17461)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -21,6 +21,9 @@
 
 using System;
+using System.ComponentModel;
 using System.Drawing;
 using System.Linq;
+using System.Threading;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -28,21 +31,17 @@
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Encodings.ScheduleEncoding;
-using HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix;
-using HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition;
-using HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector;
+using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
-using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.Problems.Instances;
 
 namespace HeuristicLab.Problems.Scheduling {
+  public enum JSSPObjective { Makespan, Tardiness }
+
   [Item("Job Shop Scheduling Problem (JSSP)", "Represents a standard Job Shop Scheduling Problem")]
   [Creatable(CreatableAttribute.Categories.CombinatorialProblems, Priority = 120)]
-  [StorableType("BB12CCEC-A109-4A26-A1C7-5A0703AB7687")]
-  public sealed class JobShopSchedulingProblem : SchedulingProblem, IProblemInstanceConsumer<JSSPData>, IProblemInstanceExporter<JSSPData>, IStorableContent {
+  [StorableType("d6c72bd1-c6cc-4efb-9cc5-b73bb3845799")]
+  public sealed class JobShopSchedulingProblem : SingleObjectiveProblem<IScheduleEncoding, IScheduleSolution>, IProblemInstanceConsumer<JSSPData>, IProblemInstanceExporter<JSSPData>, IStorableContent {
     #region Default Instance
     private static readonly JSSPData DefaultInstance = new JSSPData() {
-      Name = "Job Shop Scheduling Problem (JSSP)",
-      Description = "The default instance of the JSSP problem in HeuristicLab",
       Jobs = 10,
       Resources = 10,
@@ -75,29 +74,14 @@
     #endregion
 
-    public string Filename { get; set; }
     public override Image ItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Type; }
     }
-
+    
     #region Parameter Properties
-    public IValueParameter<ItemList<Job>> JobDataParameter {
-      get { return (IValueParameter<ItemList<Job>>)Parameters["JobData"]; }
-    }
-    public OptionalValueParameter<Schedule> BestKnownSolutionParameter {
-      get { return (OptionalValueParameter<Schedule>)Parameters["BestKnownSolution"]; }
-    }
-
-    public IFixedValueParameter<IntValue> JobsParameter {
-      get { return (IFixedValueParameter<IntValue>)Parameters["Jobs"]; }
-    }
-    public IFixedValueParameter<IntValue> ResourcesParameter {
-      get { return (IFixedValueParameter<IntValue>)Parameters["Resources"]; }
-    }
-    public IValueParameter<IScheduleEvaluator> ScheduleEvaluatorParameter {
-      get { return (IValueParameter<IScheduleEvaluator>)Parameters["ScheduleEvaluator"]; }
-    }
-    public OptionalValueParameter<IScheduleDecoder> ScheduleDecoderParameter {
-      get { return (OptionalValueParameter<IScheduleDecoder>)Parameters["ScheduleDecoder"]; }
-    }
+    [Storable] public IValueParameter<ItemList<Job>> JobDataParameter { get; private set; }
+    [Storable] public OptionalValueParameter<Schedule> BestKnownSolutionParameter { get; private set; }
+    [Storable] public IFixedValueParameter<IntValue> JobsParameter { get; private set; }
+    [Storable] public IFixedValueParameter<IntValue> ResourcesParameter { get; private set; }
+    [Storable] public IFixedValueParameter<EnumValue<JSSPObjective>> ObjectiveParameter { get; private set; }
     #endregion
 
@@ -119,11 +103,7 @@
       set { ResourcesParameter.Value.Value = value; }
     }
-    public IScheduleEvaluator ScheduleEvaluator {
-      get { return ScheduleEvaluatorParameter.Value; }
-      set { ScheduleEvaluatorParameter.Value = value; }
-    }
-    public IScheduleDecoder ScheduleDecoder {
-      get { return ScheduleDecoderParameter.Value; }
-      set { ScheduleDecoderParameter.Value = value; }
+    public JSSPObjective Objective {
+      get { return ObjectiveParameter.Value.Value; }
+      set { ObjectiveParameter.Value.Value = value; }
     }
     #endregion
@@ -131,31 +111,4 @@
     [StorableConstructor]
     private JobShopSchedulingProblem(StorableConstructorFlag _) : base(_) { }
-    private JobShopSchedulingProblem(JobShopSchedulingProblem original, Cloner cloner)
-      : base(original, cloner) {
-      RegisterEventHandlers();
-    }
-    public JobShopSchedulingProblem()
-      : base(new SchedulingEvaluator(), new JSMRandomCreator()) {
-      Parameters.Add(new ValueParameter<ItemList<Job>>("JobData", "Jobdata defining the precedence relationships and the duration of the tasks in this JSSP-Instance.", new ItemList<Job>()));
-      Parameters.Add(new OptionalValueParameter<Schedule>("BestKnownSolution", "The best known solution of this JSSP instance."));
-
-      Parameters.Add(new FixedValueParameter<IntValue>("Jobs", "The number of jobs used in this JSSP instance.", new IntValue()));
-      Parameters.Add(new FixedValueParameter<IntValue>("Resources", "The number of resources used in this JSSP instance.", new IntValue()));
-      Parameters.Add(new ValueParameter<IScheduleEvaluator>("ScheduleEvaluator", "The evaluator used to determine the quality of a solution.", new MakespanEvaluator()));
-      Parameters.Add(new OptionalValueParameter<IScheduleDecoder>("ScheduleDecoder", "The operator that decodes the representation and creates a schedule.", new JSMDecoder()));
-
-      EvaluatorParameter.GetsCollected = false;
-      EvaluatorParameter.Hidden = true;
-      ScheduleDecoderParameter.Hidden = true;
-
-      InitializeOperators();
-      Load(DefaultInstance);
-      RegisterEventHandlers();
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new JobShopSchedulingProblem(this, cloner);
-    }
-
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
@@ -163,41 +116,95 @@
     }
 
+    private JobShopSchedulingProblem(JobShopSchedulingProblem original, Cloner cloner)
+      : base(original, cloner) {
+      JobDataParameter = cloner.Clone(original.JobDataParameter);
+      BestKnownSolutionParameter = cloner.Clone(original.BestKnownSolutionParameter);
+      JobsParameter = cloner.Clone(original.JobsParameter);
+      ResourcesParameter = cloner.Clone(original.ResourcesParameter);
+      ObjectiveParameter = cloner.Clone(original.ObjectiveParameter);
+
+      RegisterEventHandlers();
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new JobShopSchedulingProblem(this, cloner);
+    }
+
+    public JobShopSchedulingProblem()
+      : base(new JobSequenceMatrixEncoding()) {
+      Parameters.Add(JobDataParameter = new ValueParameter<ItemList<Job>>("JobData", "Jobdata defining the precedence relationships and the duration of the tasks in this JSSP-Instance.", new ItemList<Job>()));
+      Parameters.Add(BestKnownSolutionParameter = new OptionalValueParameter<Schedule>("BestKnownSolution", "The best known solution of this JSSP instance."));
+      Parameters.Add(JobsParameter = new FixedValueParameter<IntValue>("Jobs", "The number of jobs used in this JSSP instance.", new IntValue()));
+      Parameters.Add(ResourcesParameter = new FixedValueParameter<IntValue>("Resources", "The number of resources used in this JSSP instance.", new IntValue()));
+      Parameters.Add(ObjectiveParameter = new FixedValueParameter<EnumValue<JSSPObjective>>("Objective", "The objective to use in the evaluation of a schedule.", new EnumValue<JSSPObjective>(JSSPObjective.Makespan)));
+      EncodingParameter.Hidden = false;
+
+      Encoding.ResourcesParameter = ResourcesParameter;
+      Encoding.JobsParameter = JobsParameter;
+      Encoding.JobDataParameter = JobDataParameter;
+
+      Load(DefaultInstance);
+      RegisterEventHandlers();
+    }
+
+    public override ISingleObjectiveEvaluationResult Evaluate(IScheduleSolution solution, IRandom random, CancellationToken cancellationToken) {
+      var schedule = Encoding.Decode(solution, JobData);
+      switch (Objective) {
+        case JSSPObjective.Makespan:
+          return new SingleObjectiveEvaluationResult(Makespan.Calculate(schedule));
+        case JSSPObjective.Tardiness:
+          return new SingleObjectiveEvaluationResult(MeanTardiness.Calculate(schedule, JobData));
+        default:
+          throw new InvalidOperationException("Objective " + Objective + " unknown");
+      }
+    }
+
+    public override void Analyze(IScheduleSolution[] solutions, double[] qualities, ResultCollection results, IRandom random) {
+      base.Analyze(solutions, qualities, results, random);
+
+      bool max = Maximization;
+
+      int i = -1;
+      if (!max)
+        i = qualities.Select((x, index) => new { index, x }).OrderBy(x => x.x).First().index;
+      else i = qualities.Select((x, index) => new { index, x }).OrderByDescending(x => x.x).First().index;
+
+      if (double.IsNaN(BestKnownQuality) ||
+          max && qualities[i] > BestKnownQuality ||
+          !max && qualities[i] < BestKnownQuality) {
+        BestKnownQuality = qualities[i];
+        BestKnownSolution = Encoding.Decode(solutions[i], JobData);
+      }
+      Schedule bestSolution;
+      if (results.TryGetValue("Best Scheduling Solution", out var result)) {
+        bestSolution = result.Value as Schedule;
+      } else bestSolution = null;
+
+      if (bestSolution == null || IsBetter(bestSolution.Quality, qualities[i]))
+        results.AddOrUpdateResult("Best Scheduling Solution", Encoding.Decode(solutions[i], JobData));
+    }
+
+    protected override void OnEncodingChanged() {
+      base.OnEncodingChanged();
+      Encoding.ResourcesParameter = ResourcesParameter;
+      Encoding.JobsParameter = JobsParameter;
+      Encoding.JobDataParameter = JobDataParameter;
+    }
+
+
     private void RegisterEventHandlers() {
-      ScheduleEvaluatorParameter.ValueChanged += ScheduleEvaluatorParameter_ValueChanged;
-      ScheduleEvaluator.QualityParameter.ActualNameChanged += ScheduleEvaluator_QualityParameter_ActualNameChanged;
-      SolutionCreator.ScheduleEncodingParameter.ActualNameChanged += SolutionCreator_SchedulingEncodingParameter_ActualNameChanged;
-      ScheduleDecoderParameter.ValueChanged += ScheduleDecoderParameter_ValueChanged;
-      if (ScheduleDecoder != null) ScheduleDecoder.ScheduleParameter.ActualNameChanged += ScheduleDecoder_ScheduleParameter_ActualNameChanged;
-    }
-
-    #region Events
-    protected override void OnSolutionCreatorChanged() {
-      base.OnSolutionCreatorChanged();
-      SolutionCreator.ScheduleEncodingParameter.ActualNameChanged += SolutionCreator_SchedulingEncodingParameter_ActualNameChanged;
-      InitializeOperators();
-    }
-    protected override void OnEvaluatorChanged() {
-      base.OnEvaluatorChanged();
-      ParameterizeOperators();
-    }
-    private void ScheduleEvaluatorParameter_ValueChanged(object sender, EventArgs eventArgs) {
-      ScheduleEvaluator.QualityParameter.ActualNameChanged += ScheduleEvaluator_QualityParameter_ActualNameChanged;
-      ParameterizeOperators();
-    }
-    private void ScheduleEvaluator_QualityParameter_ActualNameChanged(object sender, EventArgs eventArgs) {
-      ParameterizeOperators();
-    }
-
-    private void SolutionCreator_SchedulingEncodingParameter_ActualNameChanged(object sender, EventArgs eventArgs) {
-      ParameterizeOperators();
-    }
-    private void ScheduleDecoderParameter_ValueChanged(object sender, EventArgs eventArgs) {
-      if (ScheduleDecoder != null) ScheduleDecoder.ScheduleParameter.ActualNameChanged += ScheduleDecoder_ScheduleParameter_ActualNameChanged;
-      ParameterizeOperators();
-    }
-    private void ScheduleDecoder_ScheduleParameter_ActualNameChanged(object sender, EventArgs eventArgs) {
-      ParameterizeOperators();
-    }
-    #endregion
+      JobDataParameter.ValueChanged += JobDataParameterOnValueChanged;
+      JobData.PropertyChanged += JobDataOnPropertyChanged;
+    }
+
+    private void JobDataParameterOnValueChanged(object sender, EventArgs e) {
+      JobData.PropertyChanged += JobDataOnPropertyChanged;
+      Jobs = JobData.Count;
+    }
+
+    private void JobDataOnPropertyChanged(object sender, PropertyChangedEventArgs e) {
+      if (e.PropertyName == nameof(JobData.Count)) {
+        Jobs = JobData.Count;
+      }
+    }
 
     #region Problem Instance Handling
@@ -212,24 +219,25 @@
       }
 
-      BestKnownQuality = data.BestKnownQuality.HasValue ? new DoubleValue(data.BestKnownQuality.Value) : null;
+      BestKnownQuality = data.BestKnownQuality ?? double.NaN;
       if (data.BestKnownSchedule != null) {
-        var enc = new JSMEncoding();
-        enc.JobSequenceMatrix = new ItemList<Permutation>(data.Resources);
+        var enc = new JSM(0);
         for (int i = 0; i < data.Resources; i++) {
-          enc.JobSequenceMatrix[i] = new Permutation(PermutationTypes.Absolute, new int[data.Jobs]);
+          enc.JobSequenceMatrix.Add(new Permutation(PermutationTypes.Absolute, new int[data.Jobs]));
           for (int j = 0; j < data.Jobs; j++) {
             enc.JobSequenceMatrix[i][j] = data.BestKnownSchedule[i, j];
           }
         }
-        BestKnownSolution = new JSMDecoder().CreateScheduleFromEncoding(enc, jobData);
-        if (ScheduleEvaluator is MeanTardinessEvaluator)
-          BestKnownQuality = new DoubleValue(MeanTardinessEvaluator.GetMeanTardiness(BestKnownSolution, jobData));
-        else if (ScheduleEvaluator is MakespanEvaluator)
-          BestKnownQuality = new DoubleValue(MakespanEvaluator.GetMakespan(BestKnownSolution));
-      }
-      Name = data.Name;
-      Description = data.Description;
+        BestKnownSolution = JSMDecoder.Decode(enc, jobData, JSMDecodingErrorPolicy.RandomPolicy, JSMForcingStrategy.SwapForcing);
+        switch (Objective) {
+          case JSSPObjective.Makespan:
+            BestKnownQuality = Makespan.Calculate(BestKnownSolution);
+            break;
+          case JSSPObjective.Tardiness:
+            BestKnownQuality = MeanTardiness.Calculate(BestKnownSolution, jobData);
+            break;
+        }
+      }
+
       JobData = jobData;
-      Jobs = data.Jobs;
       Resources = data.Resources;
     }
@@ -259,79 +267,4 @@
     #endregion
 
-    #region Helpers
-    private void InitializeOperators() {
-      Operators.Clear();
-      ApplyEncoding();
-      Operators.Add(new BestSchedulingSolutionAnalyzer());
-      ParameterizeOperators();
-    }
-
-    private void ApplyEncoding() {
-      if (SolutionCreator.GetType() == typeof(JSMRandomCreator)) {
-        Operators.AddRange(ApplicationManager.Manager.GetInstances<IJSMOperator>());
-        ScheduleDecoder = new JSMDecoder();
-      } else if (SolutionCreator.GetType() == typeof(PRVRandomCreator)) {
-        Operators.AddRange(ApplicationManager.Manager.GetInstances<IPRVOperator>());
-        ScheduleDecoder = new PRVDecoder();
-      } else if (SolutionCreator.GetType() == typeof(PWRRandomCreator)) {
-        Operators.AddRange(ApplicationManager.Manager.GetInstances<IPWROperator>());
-        ScheduleDecoder = new PWRDecoder();
-      } else if (SolutionCreator.GetType() == typeof(DirectScheduleRandomCreator)) {
-        Operators.AddRange(ApplicationManager.Manager.GetInstances<IDirectScheduleOperator>());
-        ScheduleDecoder = null;
-      }
-    }
-
-    private void ParameterizeOperators() {
-      Evaluator.ScheduleDecoderParameter.ActualName = ScheduleDecoderParameter.Name;
-      Evaluator.ScheduleDecoderParameter.Hidden = true;
-      Evaluator.ScheduleEvaluatorParameter.ActualName = ScheduleEvaluatorParameter.Name;
-      Evaluator.ScheduleEvaluatorParameter.Hidden = true;
-      Evaluator.QualityParameter.ActualName = ScheduleEvaluator.QualityParameter.ActualName;
-      Evaluator.QualityParameter.Hidden = true;
-
-      if (ScheduleDecoder != null)
-        ScheduleDecoder.ScheduleEncodingParameter.ActualName = SolutionCreator.ScheduleEncodingParameter.ActualName;
-
-      if (ScheduleDecoder != null) {
-        ScheduleEvaluator.ScheduleParameter.ActualName = ScheduleDecoder.ScheduleParameter.ActualName;
-        ScheduleEvaluator.ScheduleParameter.Hidden = true;
-      } else if (SolutionCreator is DirectScheduleRandomCreator) {
-        var directEvaluator = (DirectScheduleRandomCreator)SolutionCreator;
-        ScheduleEvaluator.ScheduleParameter.ActualName = directEvaluator.ScheduleEncodingParameter.ActualName;
-        ScheduleEvaluator.ScheduleParameter.Hidden = true;
-      } else {
-        ScheduleEvaluator.ScheduleParameter.ActualName = ScheduleEvaluator.ScheduleParameter.Name;
-        ScheduleEvaluator.ScheduleParameter.Hidden = false;
-      }
-
-      foreach (var op in Operators.OfType<IScheduleManipulator>()) {
-        op.ScheduleEncodingParameter.ActualName = SolutionCreator.ScheduleEncodingParameter.ActualName;
-        op.ScheduleEncodingParameter.Hidden = true;
-      }
-
-      foreach (var op in Operators.OfType<IScheduleCrossover>()) {
-        op.ChildParameter.ActualName = SolutionCreator.ScheduleEncodingParameter.ActualName;
-        op.ChildParameter.Hidden = true;
-        op.ParentsParameter.ActualName = SolutionCreator.ScheduleEncodingParameter.ActualName;
-        op.ParentsParameter.Hidden = true;
-      }
-
-      foreach (var op in Operators.OfType<BestSchedulingSolutionAnalyzer>()) {
-        op.QualityParameter.ActualName = ScheduleEvaluator.QualityParameter.ActualName;
-        if (ScheduleDecoder != null) {
-          op.ScheduleParameter.ActualName = ScheduleDecoder.ScheduleParameter.ActualName;
-          op.ScheduleParameter.Hidden = true;
-        } else if (SolutionCreator is DirectScheduleRandomCreator) {
-          op.ScheduleParameter.ActualName = ((DirectScheduleRandomCreator)SolutionCreator).ScheduleEncodingParameter.ActualName;
-          op.ScheduleParameter.Hidden = true;
-        } else {
-          op.ScheduleParameter.ActualName = op.ScheduleParameter.Name;
-          op.ScheduleParameter.Hidden = false;
-        }
-      }
-    }
-    #endregion
-
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/Objectives/Makespan.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/Objectives/Makespan.cs	(revision 17461)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/Objectives/Makespan.cs	(revision 17461)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Encodings.ScheduleEncoding;
+
+namespace HeuristicLab.Problems.Scheduling {
+  public static class Makespan {
+    public static double Calculate(Schedule schedule) {
+      return schedule.Resources.Select(r => r.TotalDuration).Max();
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/Objectives/MeanTardiness.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/Objectives/MeanTardiness.cs	(revision 17461)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Scheduling/3.3/Objectives/MeanTardiness.cs	(revision 17461)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
+
+namespace HeuristicLab.Problems.Scheduling {
+  public static class MeanTardiness {
+    public static double Calculate(Schedule schedule, ItemList<Job> jobData) {
+      return schedule.Resources
+        .Select(r => Math.Max(0, r.Tasks.Last().EndTime - jobData[r.Tasks.Last().JobNr].DueDate))
+        .Average();
+    }
+  }
+}
